/* initng-conf-gtk, the gtk configuration program for initng
 * Copyright (C) 2006 Daniel Malmgren <dm@mensa.se>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General
 * Public License along with this library; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA  02110-1301, USA.
 */

#ifndef SERVICE_PARSER_H
#define SERVICE_PARSER_H

#include <gtk/gtk.h>
#include <glade/glade.h>
#include "ngehandler.h"

gboolean service_filter(GtkTreeModel *model, GtkTreeIter *iter, gpointer data);

void populate_service_list();
gboolean show_service(GtkWidget *treeview);
void change_service();
void save_all_services();
void servicelist_cleanup();

enum {
  RUNLEVEL = 0,
  SERVICE,
  DAEMON,
  VIRTUAL,
  VIRTUALFILE,
  UNKNOWN
};

struct s_file_content {
  char *data;             //Entire file contents
  gboolean needs_saving;  //Whether this file has been altered
  char *path;             //Full path to file
  gint references;        //Number of references to this struct
};

struct s_info {
  char type;         //Type (See enum above)
  char *startline;   //First line of service in file
  e_is status_id;    //Status of service
  int hidden;
  struct s_file_content *file_content; //Pointer to file contents
  char *fullname;    //Full name of service/daemon
};

gboolean add_node(GtkTreeStore *store, GtkTreeIter *iter, const char *name);

#endif
